package cn.com.qmth.dp.examcloud.oe;

import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

import cn.com.qmth.dp.examcloud.oe.modules.get_student_answer_detail.GetStduentAnswerDetailService;
import cn.com.qmth.dp.examcloud.oe.modules.update_correct_answer.FixCorrectAnswerAndResetScoreService;
import org.apache.commons.lang3.RandomUtils;
import org.bson.Document;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Component;

import com.mongodb.client.FindIterable;
import com.mongodb.client.MongoCollection;
import com.mongodb.client.MongoCursor;

import cn.com.qmth.dp.examcloud.oe.modules.export_data.ExportData;
import cn.com.qmth.examcloud.commons.logging.ExamCloudLog;
import cn.com.qmth.examcloud.commons.logging.ExamCloudLogFactory;
import cn.com.qmth.examcloud.commons.util.JsonUtil;
import cn.com.qmth.examcloud.web.support.SpringContextHolder;
import cn.com.qmth.examcloud.web.upyun.UpYunPathInfo;
import cn.com.qmth.examcloud.web.upyun.UpyunPathEnvironmentInfo;
import cn.com.qmth.examcloud.web.upyun.UpyunService;

/**
 * 任务
 *
 * @author WANGWEI
 * @date 2019年9月6日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@Component
public class Task {

    private static ExamCloudLog log = ExamCloudLogFactory.getLog(Task.class);

    /**
     * 方法注释
     *
     * @author WANGWEI
     */
    public void start() {
        try {
            FixCorrectAnswerAndResetScoreService bean = SpringContextHolder.getBean(FixCorrectAnswerAndResetScoreService.class);
            bean.start(19,"03013750");

/*//			ExportData bean = SpringContextHolder.getBean(ExportData.class);
            GetStduentAnswerDetailService bean = SpringContextHolder.getBean(GetStduentAnswerDetailService.class);
//			bean.start(1173L,"9999");
            bean.start(1191L, "100", "200", "101", "201");
			bean.start(1193L, "302", "303", "304", "305","306");
			bean.start(1192L, "300", "301", "102", "202",
					"103","203","104","204","105","205","106","206","401");
//			bean.start(764L, "A149","A150","A154");
//			bean.start(765L, "C149","C150","C154");
//			bean.start(766L, "B149","B150","B154");*/

        } catch (Exception e) {
            log.error("unexpected", e);
            throw new RuntimeException(e);
        }

    }

    /**
     * 连接测试
     *
     * @author WANGWEI
     */
    public static void test() {

        UpyunService upyunService = SpringContextHolder.getBean(UpyunService.class);
        UpyunPathEnvironmentInfo env = new UpyunPathEnvironmentInfo();
        env.setFileSuffix(".jpg");
        env.setRootOrgId(String.valueOf(RandomUtils.nextLong()));
        UpYunPathInfo upYunPathInfo = upyunService.writeFile("test", env,
                new File("D:/Temp/111111X.jpg"), true);
        System.out.println("upYunPathInfo: " + JsonUtil.toPrettyJson(upYunPathInfo));

        JdbcTemplate jdbcTemplate = SpringContextHolder.getBean(JdbcTemplate.class);
        List<Map<String, Object>> list = jdbcTemplate.queryForList("select now() from dual");
        System.out.println(JsonUtil.toJson(list));

        MongoTemplate mongoTemplate = SpringContextHolder.getBean(MongoTemplate.class);
        String dbName = mongoTemplate.getDb().getName();
        System.out.println("mongo.db=" + dbName);
        MongoCollection<Document> collection = mongoTemplate.getCollection("examRecordQuestions");
        Document filter = new Document();
        filter.append("examRecordDataId", 101373L);
        FindIterable<Document> iterable = collection.find(filter);
        MongoCursor<Document> iterator = iterable.iterator();
        while (iterator.hasNext()) {
            Document next = iterator.next();

            System.out.println("_id=" + next.getObjectId("_id"));
            System.out.println(JsonUtil.toPrettyJson(next));
        }
    }
}
